#include <stdlib.h>    
#include <stdio.h>    
    
#include "allegro.h"    
#include "brmstn.h"    
#include "brmstn2.h"    

void BattleProc();    
void AddBuff(int, int);
void BmpInit(BITMAP*);
void ClearBuffer(int);

BITMAP *bg, *img;    
BITMAP *CurAnim[2][MaxAnim];    
BITMAP *StandStill[2][StandLength], *Duck[2][DuckLength], *JumpUp[2][JumpLength];    
BITMAP *Kick[2][3][KickLength], *Punch[2][3][PunchLength];
BITMAP *DKick[2][3][DKickLength], *DPunch[2][3][DPunchLength];
BITMAP *Hit[2][3][3];
BITMAP *Advance[2][AdvLength], *Retreat[2][RetLength];
BITMAP *buffer;    

int StandHit[2][StandLength][MaxSpots][5];
int DuckHit[2][DuckLength][MaxSpots][5];
int JumpHit[2][JumpLength][MaxSpots][5];
int KickHot[2][3][KickLength][MaxSpots][4], KickHit[2][3][KickLength][MaxSpots][5];
int PunchHot[2][3][PunchLength][MaxSpots][4], PunchHit[2][3][PunchLength][MaxSpots][5];
int DPunchHot[2][3][DPunchLength][MaxSpots][4], DPunchHit[2][3][DPunchLength][MaxSpots][5];
int DKickHot[2][3][DKickLength][MaxSpots][4], DKickHit[2][3][DKickLength][MaxSpots][5];
int StandNumHit[2][StandLength];
int DuckNumHit[2][DuckLength];
int JumpNumHit[2][JumpLength];
int KickNumHot[2][3][KickLength], KickNumHit[2][3][KickLength];
int PunchNumHot[2][3][PunchLength], PunchNumHit[2][3][PunchLength];
int DPunchNumHit[2][3][DPunchLength], DPunchNumHot[2][3][DPunchLength];
int DKickNumHit[2][3][DKickLength], DKickNumHot[2][3][DKickLength];
int AdvHit[2][AdvLength][MaxSpots][5], RetHit[2][RetLength][MaxSpots][5];
int AdvNumHit[2][AdvLength], RetNumHit[2][RetLength];

SAMPLE *ow, *huck, *YouDied;

char rdHotSpots[2][1000], rdHitSpots[2][1000];
int HotSpots[2][MaxSpots][4], HitSpots[2][MaxSpots][5];
int CurHotSpots[2][MaxAnim][MaxSpots][4], CurHitSpots[2][MaxAnim][MaxSpots][5];
int CurNumHot[2][MaxAnim], CurNumHit[5][MaxAnim]; int NumHot[2], NumHit[2];
char SpecialString[1000];
int SpecCount;

PALETTE pal;    
DATAFILE *df;    
    
int LoopAnim[2], AnimCount[2], AnimSize[2], AnimSpeed[2], AcCount[2], RedrawCount;
int isDuck[2], isJump[2], isAttack[2], isHit[2], Facing[2], Life[2], isWalk[2], inBattle;
int HoldBuff[2][128], PressBuff[2][MaxBuffer];    
float chr_x[2], chr_y[2], chr_x2[2], chr_y2[2], chr_yspeed[2];   
char t;   

char CharName[2][100];
int CharSpeed[2], CharStrength[2];

int kUp[2], kLeft[2], kRight[2], kDown[2];   
int kKick[2][3], kPunch[2][3];
int kFwd, kBack;
int Fwd[2], Back[2];

void main() {    
int j;    
allegro_init();    
install_keyboard();    
set_gfx_mode(GFX_AUTODETECT, 640, 480, 0, 0);
install_sound(DIGI_AUTODETECT, MIDI_NONE, NULL);
text_mode(-1);

buffer = create_bitmap(SCREEN_W, SCREEN_H);

kUp[0] = KEY_UP;
kLeft[0] = KEY_LEFT;
kRight[0] = KEY_RIGHT;
kDown[0] = KEY_DOWN;
kPunch[0][0] = KEY_O;
kPunch[0][1] = KEY_P;
kPunch[0][2] = KEY_OPENBRACE;
kKick[0][0] = KEY_L;
kKick[0][1] = KEY_COLON;
kKick[0][2] = KEY_QUOTE;

kUp[1] = KEY_UP;
kLeft[1] = KEY_LEFT;
kRight[1] = KEY_RIGHT;
kDown[1] = KEY_DOWN;
kPunch[1][0] = KEY_O;
kPunch[1][1] = KEY_P;
kPunch[1][2] = KEY_OPENBRACE;
kKick[1][0] = KEY_L;
kKick[1][1] = KEY_COLON;
kKick[1][2] = KEY_QUOTE;

/* kUp[1] = 1;
kLeft[1] = 1;
kRight[1] =1;
kDown[1] =1;
kKick[1][0] = 1;
kPunch[1][0] =1; */

BattleProc();
exit(0);
}    
    
void BattleProc() {    
int j, k, m, n, c, ext = NULL, p[2], shift, f, fa[2], pf;
int HotX1, HotX2, HotY1, HotY2, HitX1, HitX2, HitY1, HitY2, IntrX1, IntrX2, IntrY1, IntrY2;
int HitF[2], op, Special, Special2;
char tStr[5][1000], temp[1000], tInt[MaxBuffer];
int tSz, Count, NumCoords, NumEls;

isDuck[0] = NULL;    
for (j = 0; j < 2; ++j) {
	Facing[j] = j;
	Life[j] = StartLife;
	for (k = 0; k < MaxAnim; ++k) {
		CurNumHot[j][k] = -1;
		CurNumHit[j][k] = 0;
		CurHitSpots[j][k][0][0] = 0;
		CurHitSpots[j][k][0][1] = 0;
		CurHitSpots[j][k][0][2] = 100;
		CurHitSpots[j][k][0][3] = 100;
		}
	}
    
/* Load sprites. */    
p[0] = 0;    
p[1] = 0;    
    
df = load_datafile("brmstn.dat");    
if (!df) {    
	printf("Error loading data file. Exiting.\n");    
	exit(1);    
	}    
    
for (k=0;k<2;++k) {
	shift = p[k] * NumChars;
	for (j = 0; j < StandLength; ++j) {    
		img = (BITMAP*)df[j+shift+StandShift].dat;    
		StandStill[k][j] = create_bitmap(img->w, img->h);
		BmpInit(StandStill[k][j]);
		blit(img, StandStill[k][j], 0, 0, 0, 0, img->w, img->h);     
		CurAnim[k][j] = StandStill[k][j];
		} 
	AnimSize[k] = StandLength-1;    
	LoopAnim[k] = 1;    
	AnimCount[k] = -1;
	chr_y[k] = 0;
	for (j = 0; j < DuckLength; ++j) {    
		img = (BITMAP*)df[j+shift+DuckShift].dat;    
		Duck[k][j] = create_bitmap(img->w, img->h);    
		BmpInit(Duck[k][j]);
		blit(img, Duck[k][j], 0, 0, 0, 0, img->w, img->h);    
		}    
	for (j = 0; j < JumpLength; ++j) {    
		img = (BITMAP*)df[j+shift+JumpUpShift].dat;    
		JumpUp[k][j] = create_bitmap(img->w, img->h);    
		BmpInit(JumpUp[k][j]);
		blit(img, JumpUp[k][j], 0, 0, 0, 0, img->w, img->h);
		}
	for (j = 0; j < AdvLength; ++j) {    
		img = (BITMAP*)df[j+shift+AdvShift].dat;    
		Advance[k][j] = create_bitmap(img->w, img->h);    
		BmpInit(Advance[k][j]);
		blit(img, Advance[k][j], 0, 0, 0, 0, img->w, img->h);    
		}    
	for (j = 0; j < RetLength; ++j) {    
		img = (BITMAP*)df[j+shift+RetShift].dat;    
		Retreat[k][j] = create_bitmap(img->w, img->h);    
		BmpInit(Retreat[k][j]);
		blit(img, Retreat[k][j], 0, 0, 0, 0, img->w, img->h);    
		}    
	for (n = 0; n < 3; ++n) {
		for (j = 0; j < PunchLength; ++j) {   
			img = (BITMAP*)df[j+(n*PunchLength)+shift+PunchShift].dat;   
			Punch[k][n][j] = create_bitmap(img->w, img->h);   
			BmpInit(Punch[k][n][j]);
			blit(img, Punch[k][n][j], 0, 0, 0, 0, img->w, img->h);
			// if (n==2) CurAnim[k][j] = Punch[k][n][j];
			}
		for (j = 0; j < KickLength; ++j) {   
			img = (BITMAP*)df[j+(n*KickLength)+shift+KickShift].dat;   
			Kick[k][n][j] = create_bitmap(img->w, img->h);   
			BmpInit(Kick[k][n][j]);
			blit(img, Kick[k][n][j], 0, 0, 0, 0, img->w, img->h);   
			}
		for (j = 0; j < DKickLength; ++j) {   
			img = (BITMAP*)df[j+(n*DKickLength)+shift+DKickShift].dat;   
			DKick[k][n][j] = create_bitmap(img->w, img->h);   
			BmpInit(DKick[k][n][j]);
			blit(img, DKick[k][n][j], 0, 0, 0, 0, img->w, img->h);   
			}
		for (j = 0; j < DPunchLength; ++j) {   
			img = (BITMAP*)df[j+(n*DPunchLength)+shift+DPunchShift].dat;   
			DPunch[k][n][j] = create_bitmap(img->w, img->h);   
			BmpInit(DPunch[k][n][j]);
			blit(img, DPunch[k][n][j], 0, 0, 0, 0, img->w, img->h);   
			}
		}
	for (j = 0; j < 3; ++j) {
		img = (BITMAP*)df[j+shift+HitShift].dat;
		Hit[k][0][j] = create_bitmap(img->w, img->h);
		BmpInit(Hit[k][0][j]);
		blit(img, Hit[k][0][j], 0, 0, 0, 0, img->w, img->h);
		}
	for (j = 0; j < 100; ++j) rdHotSpots[k][j] = NULL;

/* Load ASCII character data. */

/*	strcpy(rdHotSpots[k], df[DatShift+p[k]].dat);
	NumCoords = 0;
	NumEls = 0;
	Count = 0;
	tSz = 0;
	Special = 0;
	for (c = 0; rdHotSpots[k][c] != '^'; ++c) {
		if (rdHotSpots[k][c] == '\n' || (rdHotSpots[k][c] == ',' && NumCoords == 4) ) {
			if (Count == 0) {
				CharStrength[k] = atoi(temp);
				}
			else if (Count >= DuckShift && Count < HitShift) {
				strcpy(tStr[3], temp);
				DuckNumHit[k][Count-DuckShift] = NumEls;
				for (j = 0; j < NumEls+1; ++j)
				for (n = 0; n < 4; ++n)
					DuckHit[k][Count-DuckShift][j][n] = atoi(tStr[n]);
				}
			else if (Count >= HitShift && Count < JumpUpShift) {
				}
			else if (Count >= JumpUpShift && Count < KickShift) {
				strcpy(tStr[3], temp);
				JumpNumHit[k][Count-JumpUpShift] = NumEls;
				 for (j = 0; j < NumEls+1; ++j)
					for (n = 0; n < 4; ++n)
						JumpHit[k][Count-JumpUpShift][j][n] = atoi(tStr[n]);
				}
			else if (Count >= KickShift && Count < PunchShift) {
				strcpy(tStr[3], temp);
				m = (int)((Count-KickShift)/KickLength);
				t = (Count - KickShift) - (m * KickLength);
				KickNumHit[k][m][t] = NumEls;
				for (j = 0; j < NumEls+1; ++j)
					for (n = 0; n < 4; ++n)
						KickHit[k][m][t][j][n] = atoi(tStr[n]);
				}
			else if (Count >= PunchShift && Count < StandShift) {
				strcpy(tStr[3], temp);
				m = (int)((Count-PunchShift)/PunchLength);
				t = (Count - PunchShift) - (m * PunchLength);
				PunchNumHit[k][m][t] = NumEls;
				for (j = 0; j < NumEls+1; ++j)
					for (n = 0; n < 4; ++n)
						PunchHit[k][m][t][j][n] = atoi(tStr[n]);
				}
			else if (Count >= StandShift && Count < AllShift) {
				strcpy(tStr[3], temp);
				StandNumHit[k][Count-StandShift] = NumEls; for (j = 0; j < NumEls+1; ++j)
				for (n = 0; n < 4; ++n)
					StandHit[k][Count-StandShift][j][n] = atoi(tStr[n]);
				}
			else if (Count >= AllShift && Count < PunchShift2) {
				strcpy(tStr[3], temp);
				m = (int)((Count-AllShift)/KickLength);
				t = (Count - AllShift) - (m * KickLength);
				KickNumHot[k][m][t] = NumEls;
				for (j = 0; j < NumEls+1; ++j)
					for (n = 0; n < 4; ++n)
						KickHot[k][m][t][j][n] = atoi(tStr[n]);
				}
			else if (Count >= PunchShift2 && Count < KickShift2) {
				strcpy(tStr[3], temp);
				m = (int)((Count-PunchShift2)/PunchLength);
				t = (Count - PunchShift2) - (m * PunchLength);
				PunchNumHot[k][m][t] = NumEls;
				for (j = 0; j < NumEls+1; ++j)
					for (n = 0; n < 4; ++n)
						PunchHot[k][m][t][j][n] = atoi(tStr[n]);
				}
			if (rdHotSpots[k][c] == '\n') {
				++Count;
				NumEls = 0;
				NumCoords = 0;
				}
			else {
				++NumEls;
				NumCoords = 0;
				}
			for (j = 0; j < 100; ++j) temp[j] = NULL;
			tSz = 0;
			}
		else if (rdHotSpots[k][c] == ',') {
			if (Count == 0) {
				if (NumEls++ == 0)
					strcpy(CharName[k], temp);
				else if (NumEls == 1)
					CharSpeed[k] = atoi(temp);
				}
			strcpy(tStr[NumCoords++], temp); for (j = 0; j < 100; ++j) temp[j] = NULL;
			tSz = 0;
			}
		else {
			temp[tSz++] = rdHotSpots[k][c];
			temp[tSz+1] = '\0';
			}
		}*/
	}

/* exit(1); */

chr_x2[0] = 60;    
chr_x2[1] = SCREEN_W - CurAnim[1][0]->w + 150;

img = (BITMAP*)df[BKG].dat;    
bg = create_bitmap(SCREEN_W, SCREEN_H);    
blit(img, bg, 0, 0, 0, 0, SCREEN_W, SCREEN_H);    

/* Load sounds. */
ow = (SAMPLE*)df[SND01_OW].dat;
huck = (SAMPLE*)df[SND01_SPCL_01].dat;
YouDied = (SAMPLE*)df[SND_YOU_DIED].dat;
    
set_palette(df[PALLETE_001].dat);    
unload_datafile(df);    
/* Done loading. */    
/* BmpInit(screen);    
BmpInit(buffer); */

/* Begin main game loop. */

inBattle = 1;
while (!ext) {

	if (++RedrawCount > RedrawSpeed) {

/* Involuntary movement. (2) */
		for (j = 0; j < 2; ++j) {
			if (Facing[j] == 0) {
				Fwd[j] = 1;
				Back[j] = -1;
				}
			else {
				Fwd[j] = -1;
				Back[j] = 1;
				}
			if (isJump[j]) {    
				chr_yspeed[j] -= Gravity;   
				chr_y[j] += chr_yspeed[j];    
				if (chr_y[j] < 0) {    
					chr_y[j] = 0;    
					for (k = 0; k < StandLength; ++k) CurAnim[j][k] = StandStill[j][k];    
					AnimSize[j] = StandLength - 1;
					LoopAnim[j] = 1;
					isJump[j] = NULL;    
					}    
				}
			}

/* Animation and redraw. */
		RedrawCount = 0;    
		blit(bg, buffer, 0, 0, 0, 0, bg->w, bg->h);
		for (j=0;j<2;++j) {
			fa[j] = NULL;
			if (AnimCount[j] <= AnimSize[j]) {
				if (++AcCount[j] >= AnimSpeed[j]) {
					++AnimCount[j];
					AcCount[j] = 0;
					}
				}
			if (AnimCount[j] > AnimSize[j]) {
				/* printf("%d/%d:", isAttack[j], isHit[j]); */
				if (LoopAnim[j])
					AnimCount[j] = 0;
				else if (!isAttack[j] && !isHit[j])
					AnimCount[j] = AnimSize[j];
				else
					fa[j] = 1;
				}    

			/* printf("%d:%d/%d/%d ", j, AcCount[j], AnimCount[j], AnimSize[j]); */
			}

/* Draw characters. */

		for (j = 0; j < 2; ++j) {
			if (Facing[j] == 0) {
				chr_x[j] = chr_x2[j];
				draw_sprite(buffer, CurAnim[j][AnimCount[j]],(int)chr_x[j], SCREEN_H - CurAnim[j][AnimCount[j]]->h - Ground - (int)chr_y[j]);
				}
			else {
				chr_x[j] = chr_x2[j] - CurAnim[j][AnimCount[j]]->w;
				draw_sprite_h_flip(buffer, CurAnim[j][AnimCount[j]],(int)chr_x[j], SCREEN_H - CurAnim[j][AnimCount[j]]->h - Ground - (int)chr_y[j]);
				}
			for (n = 0; n < 4; ++n) {
				for (k = 0; k < CurNumHot[j][AnimCount[j]] + 1; ++k) {
					HotSpots[j][k][n] = CurHotSpots[j][AnimCount[j]][k][n];
					}
				for (k = 0; k < CurNumHit[j][AnimCount[j]] + 1; ++k) {
					HitSpots[j][k][n] = CurHitSpots[j][AnimCount[j]][k][n];
					}
				NumHot[j] = CurNumHot[j][AnimCount[j]];
				NumHit[j] = CurNumHit[j][AnimCount[j]];
				}
			} 

/* End attacks */

 		for (j = 0; j < 2; ++j) {
			if (fa[j]) {
				if (isDuck[j]) {
					for (k = 0; k < DuckLength; ++k)
						CurAnim[j][k] = Duck[j][k];
					AnimSize[j] = DuckLength - 1;
					LoopAnim[j] = NULL;
					AnimCount[j] = DuckLength;
					AcCount[j] = 0;
					AnimSpeed[j] = 0;
					isAttack[j] = NULL;
					isHit[j] = NULL;
					for (k = 0; k < DuckLength; ++k) {
						CurNumHot[j][k] = -1;
						CurNumHit[j][k] = DuckNumHit[j][k];
						for (m = 0; m < CurNumHit[j][k]+1; ++m) {
							for (n = 0; n < 5; ++n)
							CurHitSpots[j][k][m][n] = DuckHit[j][k][m][n];
							}
						}
					}
				else {
					for (k = 0; k < StandLength; ++k)
						CurAnim[j][k] = StandStill[j][k];
					AnimSize[j] = StandLength - 1;
					LoopAnim[j] = 1;
					AnimCount[j] = -1;
					AcCount[j] = 0;
					AnimSpeed[j] = 0;
					isAttack[j] = NULL;
					isHit[j] = NULL;
					for (k = 0; k < StandLength; ++k) {
						CurNumHot[j][k] = -1;
						CurNumHit[j][k] = StandNumHit[j][k];
						for (m = 0; m <= CurNumHit[j][k]; ++m)
							for (n = 0; n < 5; ++n)
								CurHitSpots[j][k][m][n] = StandHit[j][k][m][n];
						}
					}
				}
			}

   
/* Hit detection. */
/*	for (k = 0; k < 2; ++k) {
		HitF[k] = NULL;
		}

	 for (k = 0; k < 2; ++k) {
		op = !k;
		if (NumHot[k] > -1 && AcCount[k] == 0 && (!isHit[k] || (isHit[k] && AnimCount[k]>0))) {
			for (n = 0; n < NumHot[k] + 1; ++n) {
				HotX1 = HotSpots[k][n][0] + chr_x[k];
				HotY1 = HotSpots[k][n][1] + chr_y[k];
				HotX2 = HotSpots[k][n][2] + chr_x[k];
				HotY2 = HotSpots[k][n][3] + chr_y[k];
				for (j = 0; j < NumHit[op] + 1; ++j) {
					HitX1 = HitSpots[op][j][0] + chr_x[op];
					HitY1 = HitSpots[op][j][1] + chr_y[op];
					HitX2 = HitSpots[op][j][2] + chr_x[op];
					HitY2 = HitSpots[op][j][3] + chr_y[op];
printf("[%d/%d/%d]:(%d,%d)-(%d,%d):(%d,%d)-(%d,%d) ", k, n, j, HotX1, HotY1, HotX2, HotY2, HitX1, HitY1, HitX2, HitY2);
					if (HotX1 <= HitX2 && HotX2 >= HitX1 && HotY1 <= HitY2 && HotY2 >= HitY1) HitF[op]=1;
					}
				}
			if (HitF[op]) {
				isHit[op] = 1;
				Life[op] -= 5;
				for (j = 0; j < 3; ++j) CurAnim[op][j] = Hit[op][0][j];
				AnimSize[op] = 2;
				AnimSpeed[op] = 0;
				LoopAnim[op] = NULL;
				AnimCount[op] = 0;
				AcCount[op] = 0;
				play_sample(ow, 100, 100, 1000, NULL);
				}

			}
		}*/

for (j = 0; j < 2; ++j) if (Life[j] < 0) Life[j] = 0;

/* Add life bars and such. */
	rectfill(buffer, 15, 20, 20 + (int)(350*((float)Life[0]/(float)StartLife)), 50, 255);
	rectfill(buffer, 435, 20, 435 + (int)(350*((float)Life[1]/(float)StartLife)), 50, 255);
	rect(buffer, 15, 20, 370, 50, 0);
	rect(buffer, 435, 20, 785, 50, 0);
	textout(buffer, font, CharName[0], 15, 54, 255);
	textout(buffer, font, CharName[1], 435, 54, 255);
	/* printf("%d/%d ", Life[0], Life[1]); */
	if (inBattle) {
		if (Life[0] == 0 && Life[1] == 0) {
			inBattle = NULL;
			play_sample(YouDied, 100, 100, 1000, NULL);
			}
		else {
			for (j = 0; j < 2; ++j) {
				if (Life[j] == 0) {
					play_sample(YouDied, 100, 100, 1000, NULL);
					inBattle = NULL;
					}
				}
			}
		}
	if (Life[0] == 0 && Life[1] == 0) {
		textout_centre(buffer, font, "Mutual Annihilation!", (int)(SCREEN_W/2), (int)(SCREEN_H/3), 0);
		}
	else {
		for (j = 0; j < 2; ++j) {
			if (Life[j] == 0) {
				sprintf(tStr[0], "Player %d wins!", !j+1);
				textout_centre(buffer, font, tStr[0], (int)(SCREEN_W/2), (int)(SCREEN_H/3), 0); 
				}
			}
		}
		

	blit(buffer, screen, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
	}


/* Read keys. */    
	for (k = 0; k < 2; ++k) {   
/* Update buffers. */   
		pf = NULL;
		if (key[kDown[k]]) {
			pf = 1;
			++HoldBuff[k][kDown[k]];
			if (PressBuff[k][MaxBuffer] != kDown[k]) AddBuff(k, kDown[k]);
			}
		else
			HoldBuff[k][kDown[k]] = 0;

		if (key[kUp[k]]) {
			pf = 1;
			++HoldBuff[k][kUp[k]];
			if (PressBuff[k][MaxBuffer] != kUp[k]) AddBuff(k, kUp[k]);
			}
		else
			HoldBuff[k][kUp[k]] = 0;

		if (key[kLeft[k]]) {
			pf =1;
			++HoldBuff[k][kUp[k]];
			if (PressBuff[k][MaxBuffer] != kLeft[k]) AddBuff(k, kLeft[k]);
			}
		else
			HoldBuff[k][kLeft[k]] = 0;

		if (key[kRight[k]]) {
			pf =1;
			++HoldBuff[k][kRight[k]];
			if (PressBuff[k][MaxBuffer] != kRight[k]) AddBuff(k, kRight[k]);
			}
		else
			HoldBuff[k][kRight[k]] = 0;

		if (!pf) {
			if (HoldBuff[k][0] < MaxHold) ++HoldBuff[k][0];
			if (PressBuff[k][MaxBuffer] != 0 && HoldBuff[k][0] >= PressSpeed) AddBuff(k, 0);
			}

/* Check for key combinations. */
		if (Facing[k] == 0) {
			kFwd = kRight[k];
			kBack = kLeft[k];
			}
		else {
			kFwd = kLeft[k];
			kBack = kRight[k];
			}

		if (PressBuff[k][MaxBuffer-2] == kBack && PressBuff[k][MaxBuffer-1] == kFwd) {
			play_sample(huck, 100, 100, 1000, NULL);
			ClearBuffer(k);
			}

/* printf("(%s):(%s):(%s) ", PressBuff[k][MaxBuffer-2] == kBack, PressBuff[k][MaxBuffer-1] == kFwd, 1 == 1);
exit(1); */
		
/* Check for normal keypresses. */
		if (key[KEY_ESC]) ext=1;   

		if (!inBattle) {}
		else if (isDuck[k]) {
			for (c = 0; c < 3; ++c) {
				if (key[kKick[k][c]]) {
					for (j = 0; j < DKickLength; ++j) {
						CurAnim[k][j] = DKick[k][c][j];
						CurNumHot[k][j] = DKickNumHot[k][c][j];
						CurNumHit[k][j] = DKickNumHit[k][c][j];
						for (m = 0; m < CurNumHit[k][j]+1; ++m)
						for (n = 0; n < 5; ++n)
						CurHitSpots[k][j][m][n] = DKickHit[k][c][j][m][n];
						for (m = 0; m < CurNumHot[k][j]+1; ++m)
						for (n = 0; n < 4; ++n)
						CurHotSpots[k][j][m][n] = DKickHit[k][c][j][m][n];
						}
					LoopAnim[k] = NULL;
					AnimSize[k] = DKickLength-1;
					AnimCount[k] = 0;
					AcCount[k] = 0;
					if (c == 0)
						AnimSpeed[k] = 0;
					else if (c == 1)
						AnimSpeed[k] = 1;
					else
						AnimSpeed[k] = 2;
					isAttack[k] = 1;
					}
				if (key[kPunch[k][c]]) {
					for (j = 0; j < DPunchLength; ++j) {
						CurAnim[k][j] = DPunch[k][c][j];
						CurNumHot[k][j] = DPunchNumHot[k][c][j];
						CurNumHit[k][j] = DPunchNumHit[k][c][j];
						for (m = 0; m < CurNumHit[k][j]+1; ++m)
						for (n = 0; n < 5; ++n)
						CurHitSpots[k][j][m][n] = DPunchHit[k][c][j][m][n];
						for (m = 0; m < CurNumHot[k][j]+1; ++m)
						for (n = 0; n < 4; ++n)
						CurHotSpots[k][j][m][n] = DPunchHit[k][c][j][m][n];
						}
					LoopAnim[k] = NULL;
					AnimSize[k] = DPunchLength-1;
					AnimCount[k] = 0;
					AcCount[k] = 0;
					if (c == 0)
						AnimSpeed[k] = 0;
					else if (c == 1)
						AnimSpeed[k] = 1;
					else
						AnimSpeed[k] = 2;
					isAttack[k] = 1;
					}
				}
			if (!key[kDown[k]]) {
				for (j = 0; j < StandLength; ++j) CurAnim[k][j] = StandStill[k][j];
				AnimSize[k] = StandLength - 1;
				LoopAnim[k] = 1;
				AnimCount[k] = -1;
				/* AcCount[k] = 0; */
				for (j = 0; j < StandLength; ++j) {
					CurNumHot[k][j] = -1;
					CurNumHit[k][j] = StandNumHit[k][j];
					for (m = 0; m < CurNumHit[j][k]+1; ++m)
						for (n = 0; n < 5; ++n)
						CurHitSpots[k][j][m][n] = StandHit[k][j][m][n];
					}
				isDuck[k] = NULL;
				}
			}   
		else if (isJump[k]) {   
			}   
		else if (isAttack[k]) {
			}
		else if (isHit[k]) {
			}
		else {   
			if (key[kDown[k]]) {    
				AnimSize[k] = DuckLength - 1;    
				LoopAnim[k] = NULL;    
				AnimCount[k] = -1;    
				for (j = 0; j < DuckLength; ++j) {
					CurAnim[k][j] = Duck[k][j];
					CurNumHot[k][j] = -1;
					CurNumHit[k][j] = DuckNumHit[k][j];
					for (m = 0; m < CurNumHit[k][j]+1; ++m)
						for (n = 0; n < 5; ++n)
						CurHitSpots[k][j][m][n] = DuckHit[k][j][m][n];
					}
				isDuck[k] = 1;    
				}    
			if (key[kRight[k]]) {
				if (!isWalk[k]) {
					isWalk[k] = 1;
					if (Facing[k] == 0) {
						for (j = 0; j < AdvLength; ++j) {
							CurAnim[k][j] = Advance[k][j];
							CurNumHot[k][j] = -1;
							CurNumHit[k][j] = AdvNumHit[k][j];
							for (m = 0; m < CurNumHit[k][j]+1; ++m)
							for (n = 0; n < 5; ++n)
							CurHitSpots[k][j][m][n] = AdvHit[k][j][m][n];
							}
						AnimSize[k] = AdvLength - 1;
						LoopAnim[k] = 1;
						AnimCount[k] = -1;
						AnimSpeed[k] = 0;
						AcCount[k] = 0;
						}
					else {
						for (j = 0; j < RetLength; ++j) {
							CurAnim[k][j] = Retreat[k][j];
							CurNumHot[k][j] = -1;
							CurNumHit[k][j] = RetNumHit[k][j];
							for (m = 0; m < CurNumHit[k][j]+1; ++m)
							for (n = 0; n < 5; ++n)
							CurHitSpots[k][j][m][n] = RetHit[k][j][m][n];
							}
						AnimSize[k] = RetLength - 1;
						LoopAnim[k] = 1;
						AnimCount[k] = -1;
						AnimSpeed[k] = 0;
						AcCount[k] = 0;
						}
					}
				else
					chr_x2[k] += BaseSpeed * isWalk[k];
				}
			if (key[kLeft[k]]) {
				if (!isWalk[k]) {
					isWalk[k] = -1;
					if (Facing[k] == 1) {
						for (j = 0; j < AdvLength; ++j) {
							CurAnim[k][j] = Advance[k][j];
							CurNumHot[k][j] = -1;
							CurNumHit[k][j] = AdvNumHit[k][j];
							for (m = 0; m < CurNumHit[k][j]+1; ++m)
							for (n = 0; n < 5; ++n)
							CurHitSpots[k][j][m][n] = AdvHit[k][j][m][n];
							}
						AnimSize[k] = AdvLength - 1;
						LoopAnim[k] = 1;
						AnimCount[k] = -1;
						AnimSpeed[k] = 0;
						AcCount[k] = 0;
						}
					else {
						for (j = 0; j < RetLength; ++j) {
							CurAnim[k][j] = Retreat[k][j];
							CurNumHot[k][j] = -1;
							CurNumHit[k][j] = RetNumHit[k][j];
							for (m = 0; m < CurNumHit[k][j]+1; ++m)
							for (n = 0; n < 5; ++n)
							CurHitSpots[k][j][m][n] = RetHit[k][j][m][n];
							}
						AnimSize[k] = RetLength - 1;
						LoopAnim[k] = 1;
						AnimCount[k] = -1;
						AnimSpeed[k] = 0;
						AcCount[k] = 0;
						}
					}
				else
					chr_x2[k] += BaseSpeed * isWalk[k];
				}
			if (!key[kRight[k]] && !key[kLeft[k]] && isWalk[k]) {
				isWalk[k] = NULL;
				for (j = 0; j < StandLength; ++j) CurAnim[k][j] = StandStill[k][j];
				AnimSize[k] = StandLength - 1;
				LoopAnim[k] = 1;
				AnimCount[k] = -1;
				AcCount[k] = 0;
				AnimSpeed[k] = 0;
				for (j = 0; j < StandLength; ++j) {
					CurNumHot[k][j] = -1;
					CurNumHit[k][j] = StandNumHit[k][j];
					for (m = 0; m < CurNumHit[j][k]+1; ++m)
						for (n = 0; n < 5; ++n)
						CurHitSpots[k][j][m][n] = StandHit[k][j][m][n];
					}
				}
			if (key[kUp[k]]) {
				for (j = 0; j < 2; ++j) CurAnim[k][j] = JumpUp[k][j];
				LoopAnim[k] = NULL;
				AnimSize[k] = 1;    
				AnimCount[k] = -1;
				AcCount[k] = 0;
				chr_yspeed[k] = JumpStart;
				isJump[k] = 1;
				}
			for (c = 0; c < 3; ++c) {
				if (key[kKick[k][c]]) {
					for (j = 0; j < KickLength; ++j) {
						CurAnim[k][j] = Kick[k][c][j];
						CurNumHot[k][j] = KickNumHot[k][c][j];
						CurNumHit[k][j] = KickNumHit[k][c][j];
						for (m = 0; m < CurNumHit[k][j]+1; ++m)
						for (n = 0; n < 5; ++n)
						CurHitSpots[k][j][m][n] = KickHit[k][c][j][m][n];
						for (m = 0; m < CurNumHot[k][j]+1; ++m)
						for (n = 0; n < 4; ++n)
						CurHotSpots[k][j][m][n] = KickHit[k][c][j][m][n];
						}

					LoopAnim[k] = NULL;
					AnimSize[k] = KickLength-1;
					AcCount[k] = 0;
					AnimCount[k] = 0;
					if (c == 0)
						AnimSpeed[k] = 0;
					else if (c == 1)
						AnimSpeed[k] = 1;
					else
						AnimSpeed[k] = 2;
					isAttack[k] = 1;
					}
				if (key[kPunch[k][c]]) {
					for (j = 0; j < PunchLength; ++j) {
						CurAnim[k][j] = Punch[k][c][j];
						CurNumHot[k][j] = PunchNumHot[k][c][j];
						CurNumHit[k][j] = PunchNumHit[k][c][j];
						for (m = 0; m < CurNumHit[k][j]+1; ++m)
						for (n = 0; n < 5; ++n)
						CurHitSpots[k][j][m][n] = PunchHit[k][c][j][m][n];
						for (m = 0; m < CurNumHot[k][j]+1; ++m)
						for (n = 0; n < 4; ++n)
						CurHotSpots[k][j][m][n] = PunchHit[k][c][j][m][n];
						}
					LoopAnim[k] = NULL;
					AnimSize[k] = PunchLength-1;
					AnimCount[k] = 0;
					AcCount[k] = 0;
					if (c == 0)
						AnimSpeed[k] = 0;
					else if (c == 1)
						AnimSpeed[k] = 1;
					else
						AnimSpeed[k] = 2;
					isAttack[k] = 1;
					}
				}
			}
		}	   
	}

allegro_exit();    
/* printf("%s", rdHotSpots[0]); */
/* for (j = 0; j < DuckLength; ++j) {
	printf("Duck%d: ", j);
	for (k = 0; k < 4; ++k)
		printf("%d ", DuckHit[0][j][0][k]);
	printf("  ");
	}
for (j = 0; j < JumpLength; ++j) {
	printf("Jump%d: ", j);
	for (k = 0; k < 4; ++k)
		printf("%d ", JumpHit[0][j][0][k]);
	printf("  ");
	}
for (n = 0; n < 3; ++n)
	for (j = 0; j < KickLength; ++j) {
		printf("Kick%d/%d: ", n, j);
		for (k = 0; k < 4; ++k)
			printf("%d ", KickHit[0][n][j][0][k]);
		printf("  ");
		}
for (n = 0; n < 3; ++n)
	for (j = 0; j < PunchLength; ++j) {
		printf("Punch%d/%d: ", n, j);
		for (k = 0; k < 4; ++k)
			printf("%d ", PunchHit[0][n][j][0][k]);
		printf("  ");
		}
for (j = 0; j < StandLength; ++j) {
	printf("Stand%d: ", j);
	for (k = 0; k < 4; ++k)
		printf("%d ", StandHit[0][j][0][k]);
	printf("  ");
	}
printf("\n--\n");
for (n = 0; n < 3; ++n)
	for (j = 0; j < KickLength; ++j) {
		printf("Kick%d/%d: ", n, j);
		for (k = 0; k < 4; ++k)
			printf("%d ", KickHot[0][n][j][0][k]);
		printf("  ");
		}
for (n = 0; n < 3; ++n)
	for (j = 0; j < PunchLength; ++j) {
		printf("Punch%d/%d: ", n, j);
		for (k = 0; k < 4; ++k)
			printf("%d ", PunchHot[0][n][j][0][k]);
		printf("  ");
		} */


/* for (j = 0; j < MaxBuffer; ++j) printf("%d ", PressBuff[0][j]);
printf("%d/%d", Special, Special2); */
return;
}    
    
void BmpInit(BITMAP *bmp) {    
clear(bmp);    
set_clip(bmp, 0, 0, bmp->w, bmp->h);    
}    
    
void AddBuff(int p,int KeyCode) {    
int j;    
for (j=0;j<MaxBuffer;++j) PressBuff[p][j] = PressBuff[p][j+1];
PressBuff[p][MaxBuffer] = KeyCode;    
}

void ClearBuffer(int p) {
int j;
for (j = 0; j < MaxBuffer+1; ++j) PressBuff[p][j] = 0;
}
